<template>
    <header class="site-header" :class="{'scrolled': isScrolled}">
        <div class="container animate__animated animate__fasted" :class="{'animate__fadeInDown': isScrolled}"
             ref="header">
            <AppLogo></AppLogo>
            <slot></slot>
        </div>
    </header>
</template>

<script>
    import AppLogo from "./AppLogo";

    export default {
        name: "AppHeader",
        data: function () {
            return {
                hasScrolled: this.scrolled
            }
        },
        props: {
            scrolled: {
                type: Boolean,
                default: () => false
            },
            scrollHandler: {
                type: Boolean,
                default: () => true
            }
        },
        components: {
            AppLogo
        },
        methods: {
            handleScroll() {
                this.hasScrolled = window.scrollY > this.$refs.header.offsetTop + 22;
            }
        },
        computed: {
            isScrolled() {
                return this.hasScrolled;
            }
        },
        created() {
            if (this.scrollHandler) {
                window.addEventListener("scroll", this.handleScroll);
            }
        },
        destroyed() {
            if (this.scrollHandler) {
                window.removeEventListener("scroll", this.handleScroll);
            }
        }
    };
</script>

<style scoped lang="scss">
    .site-header {
        position: fixed;
        top: 55px;
        left: 0;
        display: flex;
        justify-content: center;
        width: 100%;
        z-index: 5;

        .container {
            display: flex;
            justify-content: space-between;
            align-items: center;
            max-width: 1348px;
            width: 100%;
            padding: 0 80px;
        }

        &.scrolled::v-deep {
            position: fixed;
            top: 0;
            left: 0;
            width: 100%;
            height: 92px;
            margin-top: 32px;
            z-index: 5;

            .container {
                position: relative;

                &:after {
                    position: absolute;
                    top: 0;
                    left: calc((100vw - 100%) / -2 + 45px);
                    width: calc(100vw - 90px);
                    height: 100%;
                    box-shadow: 0 59px 109px rgba(#BAC3CD, .16), 0 65px 71px rgba(#BAC3CD, .16), 0 -59px 109px rgba(#BAC3CD, .16), 0 -65px 71px rgba(#BAC3CD, .16);
                    background: white;
                    z-index: 10;
                    display: block;
                    content: '';
                }

                & * {
                    z-index: 11;
                }

                .site-logo {
                    width: 316px;

                    img {
                        height: 54px;
                    }
                }
            }
        }
    }

    @media (min-width: 1200px) and (max-width: 1440px) {
        .site-logo {
            width: 250px !important;
        }
    }

    @media (min-width: 992px) and (max-width: 1199px) {
        .site-logo {
            width: 190px !important;
        }
    }

    @media (min-width: 768px) and (max-width: 991.99px) {
        .site-header {
            .container {
                padding: 0 20px;
            }

            &.scrolled::v-deep {
                .container {
                    &:after {
                        left: calc((100vw - 100%) / -2 + 15px);
                        width: calc(100vw - 30px);
                        height: 100%;
                    }
                }
            }
        }
    }

    @media  (max-width: 767.99px) {
        .site-header {
            top: 25px;
            height: 71px;

            .container {
                padding: 0 20px;
            }

            &.scrolled::v-deep {
                .container {
                    &:after {
                        left: calc((100vw - 100%) / -2 + 15px);
                        width: calc(100vw - 30px);
                        height: 100%;
                    }
                }
            }
        }
    }
</style>
